﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace helyjegy
{
    class Jegy
    {
        public int ID { get; set; }
        public int Hely { get; set; }
        public int Fel { get; set; }
        public int Le { get; set; }
        public int Táv ()
        {
            return Le - Fel;
        }
        public int Ár (double egységár)
        {
            int km = Táv() / 10 + (Táv() % 10 == 0 ? 0 : 1);
            return (int)(Math.Round((km * egységár * 2) / 10) * 5);
        }
        public Jegy(int i, string[] sor)
        {
            ID = i;
            Hely = int.Parse(sor[0]);
            Fel = int.Parse(sor[1]);
            Le = int.Parse(sor[2]);
        }
    }

    class Program
    {
        static void Main(string[] args)
        {
            #region 1. feladat beolvasás
            StreamReader sr = new StreamReader("eladott.txt");
            string[] sor;
            sor = sr.ReadLine().Split(' ');
            int n = int.Parse(sor[0]);
            int hossz = int.Parse(sor[1]);
            double eár = int.Parse(sor[2]);
            Jegy[] járat = new Jegy[n];
            for (int i = 0; i < n; i++)
            {
                járat[i] = new Jegy(i, sr.ReadLine().Split(' '));
            }
            sr.Close();
            #endregion
            #region 2. feladat utolsó vásárolt jegy
            Console.WriteLine("2. feladat");
            Console.WriteLine("Az utolsó utas helye: {0}, a megtett távolság {1}.", járat[n - 1].Hely, járat[n - 1].Táv());
            #endregion
            #region 3. feladat végigutazók
            Console.WriteLine("3. feladat - végigutazók");
            for (int i = 0; i < n; i++)
            {
                if (járat[i].Fel == 0 && járat[i].Le == hossz)
                {
                    Console.Write((i + 1) + " ");
                }
            }
            Console.WriteLine();
            #endregion
            #region 4. feladat bevétel
            Console.WriteLine("4. feladat");
            int bevétel = 0;
            for (int i = 0; i < n; i++)
            {
                bevétel += járat[i].Ár(eár);
            }
            Console.WriteLine("A járaton a cégnek {0} Ft bevétele volt.", bevétel);
            #endregion
            #region 5. feladat utolsó megálló (nem vég)
            Console.WriteLine("5. feladat");
            int ueáll = -1;
            int feldb = 0;
            int ledb = 0;
            for (int i = 0; i < n; i++)
            {
                if (ueáll < járat[i].Fel && járat[i].Fel != hossz)
                {
                    ueáll = járat[i].Fel;
                    feldb = 1;
                }
                else if(ueáll == járat[i].Fel)
                {
                    feldb++;
                }
            }
            for (int i = 0; i < n; i++)
            {
                if (ueáll < járat[i].Le && járat[i].Le != hossz)
                {
                    ueáll = járat[i].Le;
                    ledb = 1;
                    feldb = 0;
                }
                else if (ueáll == járat[i].Le)
                {
                    ledb++;
                }
            }
            Console.WriteLine("Az utolsó megállóban {0} felszálló és {1} leszálló volt.", feldb, ledb);
            #endregion
            #region 6. feladat megállók száma
            Console.WriteLine("6. feladat");
            bool[] stop = new bool[hossz + 1];
            for (int i = 0; i <= hossz; i++)
            {
                stop[i] = false;
            }
            for (int i = 0; i < n; i++)
            {
                stop[járat[i].Fel] = true;
                stop[járat[i].Le] = true;
            }
            int megálldb = 0;
            for (int i = 1; i < hossz; i++)
            {
                megálldb += stop[i] ? 1 : 0;
            }
            Console.WriteLine("A járat {0} helyen állt meg útközben.", megálldb);
            #endregion
            #region 7. feladat utaslista(km)
            Console.WriteLine("7. feladat");
            int[] hely = new int[49];
            for (int i = 0; i < hely.Length; i++)
            {
                hely[i] = 0;
            }
            Console.Write("Adja meg, hányadik km-nél kéri az utaslisát: ");
            int km = int.Parse(Console.ReadLine());
            for (int i = 0; i < n; i++)
            {
                if (km >= járat[i].Fel && km < járat[i].Le)
                {
                    hely[járat[i].Hely] = i + 1;
                }
            }
            StreamWriter sw = new StreamWriter("kihol.txt");
            for (int i = 1; i < hely.Length; i++)
            {
                sw.WriteLine("{0, 2}. ülés: {1}", i, hely[i] == 0? "üres": hely[i].ToString()); 
            }
            sw.Close();
            Console.WriteLine("Az utaslistát megtalálja a kihol.txt fájlban.");
            #endregion
            Console.ReadKey();
        }
    }
}
